#include <iostream>
#include <math.h>
#include <GL/gl.h>
#include "graph.h"

using namespace std;

float x_min;
float x_max;
float z_min;
float z_max;
float step_size;

func cur_func;

void set_x_min(float new_x_min) {
	x_min = new_x_min;
}

void set_x_max(float new_x_max) {
	x_max = new_x_max;
}

void set_z_min(float new_z_min) {
	z_min = new_z_min;
}

void set_z_max(float new_z_max) {
	z_max = new_z_max;
}

void set_step_size(float new_step_size) {
	step_size = new_step_size;
}

void set_func(func new_func) {
	cur_func = new_func;
}

void graph() {
	graph_smooth();
	glTranslatef(0.0, 1.0, 0.0);
//	graph_lines();
}

void graph_lines() {
	for(int z = 0; z < 100; z++) {
		glBegin(GL_LINE_STRIP);
		for(int x = 0; x < 100; x++) {
			float result;
			result = cur_func((float)x - 50.0, (float)z - 50.0);
			glColor3f(-cos((x-50) / 10.0), -cos((z-50) / 20.0), 1.0);
			glVertex3f((float)x - 50.0, result, (float)z - 50.0);
		}
		glEnd();
	}

	for(int x = 0; x < 100; x++) {
		glBegin(GL_LINE_STRIP);
		for(int z = 0; z < 100; z++) {
			float result;
			result = cur_func((float)x - 50.0, (float)z - 50.0);
			glVertex3f((float)x - 50.0, result, (float)z - 50.0);
		}
		glEnd();
	}
}

void graph_smooth() {
	float results[100][100];

	for(int z = 0; z < 100; z++) {
		for(int x = 0; x < 100; x++) {
			results[x][z] = cur_func((float)x - 50.0, (float)z - 50.0);
		}
	}

	for(int z = 0; z < 99; z++) {
		for(int x = 0; x < 99; x++) {
			glColor3f(cos((x-50) / 10.0), cos((z-50) / 20.0), 1.0);
			glBegin(GL_POLYGON);
				glVertex3f((float)x - 50.0, results[x][z], (float)z - 50.0);
				glVertex3f((float)x - 49.0, results[x+1][z], (float)z - 50.0);
				glVertex3f((float)x - 49.0, results[x+1][z+1], (float)z - 49.0);
				glVertex3f((float)x - 50.0, results[x][z+1], (float)z - 49.0);
			glEnd();
		}
	}
}

